var MINI = require('minified');
var $ = MINI.$, $$=MINI.$$, EE=MINI.EE;

MINI.M.prototype.delaySet = function(str, delay){
  var that = this;
  if(delay){
    setTimeout(function(){
      $(that).set(str);
    }, delay);
  } else {
    setTimeout(function(){
      $(that).set(str);
    });
  }
}

var muteSound = function(mute){
  if(mute){
    ig.music.volume = 0;
    ig.soundManager.volume = 0;
    $("#mute").set("+muted");
  } else {
    ig.music.volume = 1;
    ig.soundManager.volume = 1;
    $("#mute").set("-muted");
  }
}

Timer = function(speed, sel){
  var timeout, active;
  this.speed = speed;
  this.el = $(sel);
  var maxTime = 99;
  this.el.set("innerHTML", maxTime);

  this.start = function(){
    active = true;
    this.update();
  }
  
  this.update = function(){
    var that = this;
    var t = parseInt(this.el.get("innerHTML")) - 1;

    if(t < 0){
      $("#canvas").trigger("lost");
      this.stop();
    } else {
      this.el.set("innerHTML", t);
    }

    if(active)
      timeout = setTimeout(function(){that.update()}, speed);
  }

  this.stop = function(){
    active = false;
  }

  this.reset = function(){
    active = false;
    clearTimeout(timeout);
    this.el.set("innerHTML", maxTime);
  }
}

$(function(){
  var timer = new Timer(1000, "#timer");

  function resetGame(){
    ig.system.setGame(null);
    timer.reset()
  }

  function startGame(w, h, d){
    $("#game").set("-hidden");
    $(".dificultad_wrap").set("+invisible +hidden");
    $("#intro").set("+hidden");
    config.width = w;
    config.height = h;
    config.difficulty = d;
    ig.main("#canvas", GameLaberinto, 60, 805, 380, 1, Loader);
  }

  $("#canvas").on("finished", function(){
    ig.music.fadeOut(0.5);
    ig.game.fanfare.play();
    $("#game").delaySet("+hidden", 500);
    $("#win").set("-hidden");
    $("#win").delaySet("-invisible");
    setTimeout(resetGame, 500);
  });

  $("#canvas").on("loaded", function(){
    var cntdwnspeed = 1000;
    $("#countdown").set("-hidden");
    $(".tresDosUno").set("innerHTML", "3");
    setTimeout(function(){$(".tresDosUno").set("innerHTML", "2")}, cntdwnspeed);
    setTimeout(function(){$(".tresDosUno").set("innerHTML", "1")}, 2*cntdwnspeed);
    setTimeout(function(){
      // countdown finished, game starts
      $("#countdown").set("+hidden");
      ig.game.paused = false;
      timer.start();
    }, 3*cntdwnspeed);

    if(!localStorage["muted"]){
      muteSound(false);
    } else {
      muteSound(true);
    }
  });

  $("#play").on("click", function(){
    $(".dificultad_wrap").set("-hidden");
    $(".dificultad_wrap").delaySet("-invisible");
  });

  $(".btn_facil").on("click", function(){
    startGame(15, 11, "easy");
  });

  $(".btn_dificil").on("click", function(){
    startGame(21, 15, "hard");
  });

  $("#canvas").on("lost", function(){
    ig.music.fadeOut(0.5);
    ig.game.buzz.play();
    $("#game").delaySet("+hidden", 500);
    $("#ups").set("-hidden");
    $("#ups").delaySet("-invisible");
    setTimeout(resetGame, 500);
  });

  $(".volver_jugar").on("click", function(){
    $("#intro").set("-hidden");
    $(".endscreen").set("+invisible");
    $(".endscreen").delaySet("+hidden", 500);
  });

  $("#help").on("click", function(){
    if(!ig.game.paused){
      timer.stop();
      ig.game.paused = true;
      $("#helpscreen").set("-hidden")
      $("#helpscreen .globo_uno").set("-hidden");
      $("#helpscreen").delaySet("-invisible");
    }
  });

  $("#helpscreen .globo_uno").on("click", function(){
    $("#helpscreen .globo_uno").set("+hidden");
    $("#helpscreen .globo_dos").set("-hidden");
  });

  $("#helpscreen .globo_dos").on("click", function(){
    $("#helpscreen .globo_dos").set("+hidden");
    $("#helpscreen .globo_tres").set("-hidden");
  });

  $("#helpscreen .globo_tres").on("click", function(){
    $("#helpscreen .globo_tres").set("+hidden");
    $("#helpscreen").set("+hidden +invisible");
    timer.start();
    ig.game.paused = false;
  });

  var input_stack = [];
  $(document).on("|keydown", function(e){
    input_stack.push(e.which);
    var code1 = [68, 73, 69, 72, 65, 82, 68];
    var code2 = [67, 72, 65, 78, 71, 73, 84, 79];
    if(input_stack.length>code2.length){input_stack=input_stack.slice(1)}
    if(_.foldl(code1, function(a,v,i){return a && (v == input_stack[i])})){ig.game.player.speed=30;input_stack=[]}
    if(_.foldl(code2, function(a,v,i){return a && (v == input_stack[i])})){
      ig.game.player.map = _.map(ig.game.player.map, function(row){
        return _.map(row, function(){return 0});
      });input_stack=[]
    }
    $("#"+codes[e.which]).set("+pressed");
  });

  $(document).on("|keyup", function(e){
    $("#"+codes[e.which]).set("-pressed");
  });

  $("#mute").on("click", function(){
    if(localStorage["muted"]){
      muteSound(false);
      localStorage.removeItem("muted");
    } else {
      muteSound(true);
      localStorage["muted"] = "true";
    }
  });

  // preloading
  $(".hidden").set("$display", "block");
  setTimeout(function(){$(".hidden").set("$display", "")});
});
