ig.module(
  "game.player"
)
.requires(
  "impact.entity"
)
.defines(function(){
  EntityPlayer = ig.Entity.extend({

    // custom
    speed: 4,
    state: "idle",
    xoffset: config.tilesize/3-20,
    yoffset: config.tilesize/3,
    minieSheet: new ig.AnimationSheet("media/minie.png", 47, 47),
    plutoSheet: new ig.AnimationSheet("media/pluto.png", 77, 77),

    init: function(x, y, settings){
      if(config.difficulty == "easy"){
        this.animSheet =  this.minieSheet;
      } else {
        this.animSheet =  this.plutoSheet;
      }
      this.addAnim("up", 0.2, [0, 1]);
      this.addAnim("right", 0.2, [6, 7]);
      this.addAnim("down", 0.2, [2, 3]);
      this.addAnim("left", 0.2, [4, 5]);
      this.currentAnim = this.anims.right;

      this.map = settings.map;
      this.coord = {x: 1, y: 1};
      this.end = {x: settings.end.x, y: settings.end.y};
      
      this.parent(x, y, settings );
    },

    handleInput: function(){
      var moved = false;
      if(ig.input.state("up") && this.map[this.coord.y - 1][this.coord.x] == 0){
        this.changeState("up");
        this.coord.y -= 1;
        moved = true;
      } else if(ig.input.state("right") && this.map[this.coord.y][this.coord.x + 1] == 0){
        this.changeState("right");
        this.coord.x += 1;
        moved = true;
      } else if(ig.input.state("down") && this.map[this.coord.y + 1][this.coord.x] == 0){
        this.changeState("down");
        this.coord.y += 1;
        moved = true;
      } else if(ig.input.state("left") && this.map[this.coord.y][this.coord.x - 1] == 0){
        this.changeState("left");
        this.coord.x -= 1;
        moved = true;
      }
      return moved;
    },

    update: function(){
      if(this.pos.x - this.xoffset < this.coord.x * config.tilesize){
        this.pos.x += this.speed;
      } else if(this.pos.x - this.xoffset > this.coord.x * config.tilesize){
        this.pos.x -= this.speed;
      } else if(this.pos.y - this.yoffset > this.coord.y * config.tilesize){
        this.pos.y -= this.speed;
      } else if(this.pos.y - this.yoffset < this.coord.y * config.tilesize){
        this.pos.y += this.speed;
      } else {
        if(!this.handleInput())
          this.changeState("idle");
      }

      // winner
      if(_.isEqual(this.coord, this.end)){
        $("#canvas").trigger("finished");
        ig.game.paused = true;
      }

      this.parent(); 
    },

    changeState: function(newState){
      if(newState == "idle"){
        this.currentAnim.gotoFrame(1);
      } else {
        this.currentAnim = this.anims[newState];
      }
      this.state = newState
    }
  });
});
